/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
        Device            :  PIC18F27K42
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/
#include <stdint.h>
#include <stdbool.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>   // pour sprintf .etc
#include <stdarg.h>
#include "mcc_generated_files/mcc.h"

#define VERSION "2022-1206"
// rajout Etat Leds HT9170B suivant le code touche saisi au clavier
// pour faciliter le test visuel (etat des 4 leds en sorties ABCD)
//#define VERSION "2022-1121"
// corrige bug sur uint8_t Sequence[17]="123A456B789C*0#D";
// rajout nom de touche sur cde RxCx clavier
#define PACK "PIC18F-K_DFP 1.6.125"
#define HOME

uint32_t waveA  __at(0x0020);
uint8_t waveA_2 __at(0x0022);
uint32_t waveB  __at(0x0024);
uint8_t waveB_2 __at(0x0026);
uint32_t BDA_periodA __at(0x0028); 
uint32_t BDA_periodB __at(0x002C6); 
// DTMF selected row and column
uint8_t drow ;     
uint8_t dcol ;
uint8_t pwm;
uint16_t pwm_1;

// This uses dual sinewaves of 28% different amplitudes, to match the spec for "twist" in
 // telephone DTMF to ensure the higher freq has a higher amplitude, to cope with line losses.
  uint8_t Sin64L[64]={
 // const uint8_t Sin64L[64]={
  39,42,46,50,53,57,60,63,66,68,71,72,74,75,76,77,77,77,76,75,74,72,71,68,66,63,60,57,53,50,46,42,
  39,35,31,27,24,20,17,14,11,9,6,5,3,2,1,1,1,1,1,2,3,5,6,9,11,14,17,20,24,27,31,35};
  // 39,35,31,27,24,20,17,14,11,9,6,5,3,2,1,0,0,0,1,2,3,5,6,9,11,14,17,20,24,27,31,35};
 // const uint8_t Sin64H[64] = {
  uint8_t Sin64H[64] = {
  50,54,59,64,68,73,77,81,85,88,91,93,95,97,98,99,99,99,98,97, 95,93,91,88,85,81,77,73,68,64,59,54,
//  50,45,40,35,31,26,22,18,14,11,8,6,4,2,1,0,0,0,1,2,4,6,8,11,14,18,22,26,31,35,40,45};
  50,45,40,35,31,26,22,18,14,11,8,6,4,2,1,1,1,1,1,2,4,6,8,11,14,18,22,26,31,35,40,45};

 
  // defines for the DTMF sine frequencies
// Sinewave is a lookup table of 64 steps, to generate 1633 Hz each step is 1633 * 64
// 24bit Binary divider uses byte2 (/65536)
// PWM freq is 128 PIC instructions (8Mhz xtal *PLL) = 62500 Hz
// So the math is;  Fout * 64 * 65536 / Fpwm
// we can use a constant Fout * (64 * 65536 / 62500) = Fout * 67.108864
#define Frow0 46775   // 697 Hz  DTMF rows
#define Frow1 51674   // 770 Hz
#define Frow2 57177   // 852 Hz
#define Frow3 63149   // 941 Hz

#define Fcol0 81135   // 1209 Hz  DTMF columns
#define Fcol1 89657   // 1336 Hz
#define Fcol2 99120   // 1477 Hz
#define Fcol3 109589  // 1633 Hz
  

uint16_t Frow_value[4]={  697,  770, 852, 941}; // Hz
uint16_t Fcol_value[4]={ 1209,1336,1477,1633}; //hz
                         //  1     2    3    A     697
                         //  4     5    6    B     770
                         //  7     8    9    C     1477
                         //  *     0    #    D     1633

uint32_t Frow[4]={ 46775 ,51674 , 57177 , 63149};
uint32_t Fcol[4]={ 81135,89657,99120,109589};
//                    8115/67.1088864=1209
uint8_t Sequence[17]="123A456B789C*0#D";
const char Leds_HT9170B[16][5]={
"LLLH","LLHL","LLHH","HHLH", // 1 2 3 A
"LHLL","LHLH","LHHL","HHHL", // 4 5 6 B
"LHHH","HLLL","HLLH","HHHH", // 7 8 9 C
"HLHL","HLHH","HHLL","LLLL"}; // 0 * # D
signed char c0; 

#define UART1_RX_BUFFER_SIZE 128  

const uint8_t  Poids[8]={1,2,4,8,16,32,64,128};
//char Choix_de_Programme;   // choix mode RC5 H=Home S=Stree
uint16_t   i,j,k,l,m,n;
uint16_t  Rep;
uint8_t  c1,c2,c3,cx,cc;
uint8_t  temp=0;
volatile uint8_t Buffer1[UART1_RX_BUFFER_SIZE];
volatile uint16_t Index1,i1;
volatile uint8_t Flag_Buffer1=0;

uint8_t TEXTE [128];
uint8_t * txt;
uint8_t * p0;
uint8_t * p1;
uint8_t * p2;
uint8_t * px;
uint8_t CRam1[80];

volatile uint8_t Infos_envoi_DTMF =0;  // infos PORTA 4   7
uint8_t DTMF_Read=0;  // lecture module DTMF Reception
uint8_t DTMF_Write=0; // codage DTMF des infos PORTA

// compteur Timers
volatile uint16_t Count0, Count1 ;
volatile uint16_t Cpt0, Cpt1;
volatile uint16_t Flag_Timer1=0;
// pour MSabotage >2
volatile uint16_t Cpt4;   // Compteur
volatile signed int  Cpt41;  // decompteur
volatile uint16_t Flag_Timer4=0;
volatile uint16_t Count_RB0 =0;
volatile uint16_t Flag_RB0=0;
volatile uint16_t Count_0_1sec=0;
float F0,F1,F2;
uint32_t L0,L1,L2;
volatile uint16_t Flag_Timer6=0;
volatile signed int  Cpt6;  

bool Status_GIE_Bit;
volatile struct Anybits {   // 8 flags

       unsigned  Tmr0_Elapsed:1;     // for timer0 16bits
       unsigned  Tmr1_Elapsed:1;     // for timer1 16bits
       unsigned  Tmr2_Elapsed:1;     // for timer2 8bits
       unsigned  Tmr3_Elapsed:1;     // for timer3 16bits
       unsigned  Tmr4_Elapsed:1;     // for timer4 8bits
       unsigned  Tmr6_Elapsed:1;     // for timer6 8bits
       unsigned  NCO_initialise:1;   // for NCO
       unsigned  DTMF:1;
 }Drapeaux ;
 
volatile uint16_t Count_IOCA=0;
volatile uint16_t Count_IOCC=0;
volatile uint8_t  Flag_IOCA=0;
volatile uint8_t  Flag_IOCC=0;
volatile uint8_t  Old_PORTA=0;
volatile uint8_t  Old_PORTC=0; 
volatile uint8_t  Etat_Combine=0;
 

void TMR6_Init_500ms(char N);
void RAZ_UART1_Buffer1(void);
void PrintChar(char txData);
void Print (char * T1);
void CPrint (const char * T1);
void CRLF1(void);
void strConstRamCpy(uint8_t  *dest, const  uint8_t *source);

 void PWM5_Initialize(void);
  void PWM5_LoadDutyValue(uint16_t dutyValue);


void __interrupt(irq(default),base(8)) Default_ISR()
{
}

void  INTERRUPT_Init (void)
{
 
    bool state = (uint8_t)GIE;
    INTCON0bits.IPEN = 1;
    GIE = 0;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0; // unlock 
    IVTBASEU = 0;
    IVTBASEH = 0;
    IVTBASEL = 8;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 1; // lock IVT
    GIE = state;
    // Assign peripheral interrupt priority vectors
    IPR3bits.U1RXIP = 1;
 //   IPR1bits.INT0IP = 1;
    IPR4bits.TMR1IP = 1;
    IPR9bits.TMR6IP = 1;
  //  IPR7bits.TMR4IP = 0;
  //  IPR0bits.IOCIP=1;
  
}


void TMR6_Init_500ms(char N)
{   
    //  cycle=500 mS modifi -> 1sec !
     PIE9bits.TMR6IE=0 ;
     // T2PSYNC Not Synchronized; T2MODE Software control; T2CKPOL Rising Edge; T2CKSYNC Not Synchronized; 
    T6CLKCON = 0x05;    // T2CS FOSC/4 ou    0x05 pour 500Khz
    T6HLT = 0x00;
    T6TMR = 0x00;  // TMR4 0; 
    T6CON = 0x70 | 0x07 ; // Prescaler =7=> 1/128 Poscaler=7=>  1/8 =>  ticks= 512  S
    T6PR=244;   // 512 * (244+1) * 128 * 8 => 501760S ->  500mS sec
   Flag_Timer6=0;
   TMR6ON = 1;
   TMR6IF=0;
   if(N>0) 
   { 
     Cpt6=N;
      PIE9bits.TMR6IE=1 ;  // TMR6IE_bit=1;
   }
   else
   {
       PIE9bits.TMR6IE=0 ; // TMR6IE_bit=0;
        Cpt6=0;
         
   } 
 TMR6IF=0;   
 }


void __interrupt(irq(IRQ_U1RX),high_priority) UART1_rx_vect_isr(void)
{
   static char cx;
  //  U1TXB='H';  // pour debugging only
  if ( (PIR3bits.U1RXIF==1) && (PIE3bits.U1RXIE ==1) )
  {   
      c1=U1RXB;
   //   U1TXB='*'; // echo
     if ((c1==13) || (i1>UART1_RX_BUFFER_SIZE-1))
     { 
      Flag_Buffer1=1;
      Buffer1[i1]=0;
      Index1=i1;
      i1=0; 
     PIE3bits.U1RXIE =0;
     }
     else
     {
       Buffer1[i1]=c1;
       i1++;
       Index1=i1;
      } 
   } 
}

void __interrupt(irq(IRQ_TMR6),high_priority) TMR6_ISR(void)
{  
    if (  (TMR6IF==1) && (TMR6IE==1) )
    {
      if (Cpt6>0)  // decomptage maxi 32767
       {
         Cpt6--;
        }
      else
      {
        Drapeaux.Tmr6_Elapsed=1;
        TMR6IE=0;
      } 
     Flag_Timer6=1;
     TMR6IF=0;// clear the TMR6 interrupt flag
     
    }       
 }


void UART1_Init(void)
{
    U1P1L = 0x00;
    U1P1H = 0x00;
    U1P2L = 0x00;
    U1P2H = 0x00;
    U1P3L = 0x00;
    U1P3H = 0x00;
    U1CON0 = 0xB0; // BRGS high speed; MODE Asynchronous 8-bit mode; RXEN enabled; TXEN enabled; ABDEN disabled; 
    // RXBIMD Set RXBKIF on rising RX input; BRKOVR disabled; 
    // WUE disabled; SENDB disabled; ON enabled; 
    U1CON1 = 0x80;    
    // TXPOL not inverted; FLO off; C0EN Checksum Mode 0; RXPOL not inverted;
    //RUNOVF RX input shifter stops all activity; STP Transmit 1Stop bit, receiver verifies first Stop bit; 
    U1CON2 = 0x00;
    U1BRGL = 0x8A; // BRGL 138;   115200 bds
    U1BRGH = 0x00; // BRGH 0; 
    U1FIFO = 0x00; // STPMD in middle of first Stop bit; TXWRE No error; 
    // ABDIF Auto-baud not enabled or not complete; 
    // WUIF WUE not enabled by software; ABDIE disabled; 
    U1UIR = 0x00;
    // ABDOVF Not overflowed; TXCIF 0; RXBKIF No Break detected; 
    // RXFOIF not overflowed; CERIF No Checksum error; 
    U1ERRIR = 0x00;
    // TXCIE disabled; FERIE disabled; TXMTIE disabled; ABDOVE disabled;
    // CERIE disabled; RXFOIE disabled; PERIE disabled; RXBKIE disabled; 
    U1ERRIE = 0x00;
    U1CON0bits.TXEN=1;
    U1CON0bits.RXEN=1;  // enable recpetion
    PIE3bits.U1RXIE = 0;  // disable receive interrupt
}



void strConstRamCpy(uint8_t  *dest, const  uint8_t *source)
 { static uint8_t cc=0;
 cc= *(source);
  while ( cc>0 )
  { cc=*(source);
    *(dest++) =cc;
    source++ ;
  }
  *(dest) = 0 ;    // terminateur
}


void PrintChar( char txData)
{
    while(0 == PIR3bits.U1TXIF)
    {
    }
    U1TXB = txData;    // Write the data byte to the USART.
}

 void Print (char * Tc)
 { static uint16_t k;
   k=0;      
   while(*(Tc+k)>0) 
   {
     while(PIR3bits.U1TXIF==0);
     U1TXB=*(Tc+k);
    k++;
    if(k>128)break;
   }
}
 
 
  void CPrint (const char *T1)
 { 
   while(*(T1)>0) 
   {
     while(PIR3bits.U1TXIF==0);
     U1TXB=*(T1);
    T1++;
   }
}

void CRLF1(void)
{
   while(PIR3bits.U1TXIF==0);
   U1TXB=13;
    while(PIR3bits.U1TXIF==0);
   U1TXB=10;  
  }    

void RAZ_UART1_Buffer1(void)
{    
      if (PIR3bits.U1RXIF==1)   c1=U1RXB ;
      for (i1=0;i1<sizeof(Buffer1)-1;i1++) Buffer1[i1]=0;

      Flag_Buffer1 =0 ;
      U1CON0bits.U1RXEN=1;
      U1ERRIR = 0x00;
      U1ERRIE = 0x00;
      Buffer1[0]=0;
      i1=0;
      Index1=0;

      c1=0;
      PIE3bits.U1IE  = 1;       // int uart1 enabled
      PIE3bits.U1RXIE =1;  
} 


void Delay_2sec(void)
{
     __delay_ms(2000);
}  


 void PWM5_Initialize(void)
 {
    // Set the PWM PIC18 MCUs.
    // PWM5EN =1=enabled; PWM5POL=0=normal => active_hi; 
    PWM5CON = 0x80;  
    PWM5DCH = 0x00;    // DC 0; consigne=0
    PWM5DCL = 0x00;    // DC 0; 
  //  PWM5DCH = 0x7F;    // DC 127; consigne= (127<<2) +3= 511
  //  PWM5DCL = 0xC0;   //   DC 3;  
  //  CCPTMRS1bits.P5TSEL = 2;  //page 360   2=>TMR4 
  	// Selecting Timer 2
    CCPTMRS1bits.P5TSEL =1;  //page 360   1=>TMR2 
  	
 }

 void PWM5_LoadDutyValue(uint16_t dutyValue)
 {
     // Writing to 8 MSBs of PWM duty cycle in PWMDCH register
     PWM5DCH = (dutyValue & 0x03FC)>>2;
     
     // Writing to 2 LSBs of PWM duty cycle in PWMDCL register
     PWM5DCL = (dutyValue & 0x0003)<<6;
 }

void main(void)
{
    SYSTEM_Initialize();
     RC4PPS = 0x0D ;  // RC4  sortie PWM5
     RC2PPS=0;

    #ifdef STREET
    Init_Hardware_Street();
#else
    // Init_Hardware_Home();
#endif

     INTERRUPT_Init();
 
    // on occupe et nettoie les places reservees
    k= sizeof(Buffer1)-1;
    for (i=0;i<k;i++) Buffer1[i]=0;
    for (i=0;i<sizeof(CRam1)-1;i++) CRam1[i]=0;
    for (i=0;i<sizeof(TEXTE)-1;i++) TEXTE[i]=0;
    txt=&TEXTE[0];
    
    UART1_Init();
    
    txt= &TEXTE[0];
    *(txt)=0; 
    CRLF1(); 
    Cpt1=0;
    Cpt4=0;
    Cpt41=10; // par defaut 10x100=> 1sec
    Count_RB0=0;
    Count_IOCA=0;
    Count_IOCC=0;
   // Flag_Buffer1=0;
    CRLF1();
    CPrint(" Projet MPLABX : Generateur_DTMF_18F27K42_2022 (pour Portier Audiophone)\r\n");
    CPrint(" Version : "VERSION"\r\n"); 
     k=sprintf(txt," Compile le %s a %s UTC\r\n avec version XC8 :  %d et PACK %s\r\n", __DATE__, __TIME__,__XC8_VERSION,PACK);
    Print(txt);
    CPrint(" Hardware : PIC18F27K42 , FOSC interne =64MHz \r\n");
    CPrint(" UART1  RC6=TX  115200,8,N,1 \r\n");
    CPrint(" Usage de Timer1 x fois 100mS , Timer4  100mS\r\n");
#ifdef HOME
     CPrint(" Config= HOME\r\n");
#else
       CPrint(" Config= STREET\r\n");
#endif
    CRLF1();
   GIE=1; 
 // do
 // {
   
    CPrint(" Init PWR5 (sortie r-aiguille sur RC4)\r\n"); 
    PWM5_Initialize();
    CPrint(" Init Timer2 associ  PWM5 , tick=64S\r\n"); 
    T2CONbits.TMR2ON = 1; 
   
     CPrint(" Test UP "); 
     for (pwm_1=128 ; pwm_1<897; pwm_1= pwm_1+128)
      {
      sprintf(txt," Duty = %5d \r\n", pwm_1);
      Print(txt);
      LATAbits.LATA2=1;
      PWM5_LoadDutyValue(pwm_1);
      LATAbits.LATA2=0;
      Delay_2sec();
      } 
  //   do
  //  {    
  //   CPrint(" Appui sur touche  S, puis enter,  pour la suite du test\r\n"); 
  //   RAZ_UART1_Buffer1();
  //    __delay_ms(2000); 
  //  } 
  //   while( *(Buffer1)!='S');
       
  //  pwm_1=896;
  //   sprintf(txt," Duty = %5d \r\n", pwm_1);
   //  Print(txt);
   //  LATAbits.LATA2=1;
  //   PWM5_LoadDutyValue(pwm_1);
  //   LATAbits.LATA2=0; 
   //  pwm_1=1000;
  //   sprintf(txt," Duty = %5d \r\n", pwm_1);
  //   Print(txt);
  //   LATAbits.LATA2=1;
  //  PWM5_LoadDutyValue(pwm_1);
 //   LATAbits.LATA2=0;
  //  Delay_2sec();Delay_2sec(); 
 //   do
 //  {    
 //    CPrint(" Appui sur touche Q clavier ,ouis Enter pour sortir du test\r\n"); 
  //   RAZ_UART1_Buffer1();
  //    __delay_ms(2000); 
  //  } 
  //   while( Flag_Buffer1==0);
 // }while(*(Buffer1)!='Q');
    
     CPrint(" Init et test Timer6 -> 8 x 500mS : ");
    TMR6_Init_500ms(8);
    TMR6IE=1;    
    GIE=1;
    while( Drapeaux.Tmr6_Elapsed==0) 
    {
     PrintChar('.');
     __delay_ms(500);
    }
    CRLF1();
    
    CRLF1();
    CPrint(" Sinewave DTMF generator\r\n");
    CPrint(" Select the 2 DTMF tones\r\n");
    CPrint(" Row :   697    770    852    941    OFF\r\n");
    CPrint(" Col :  1209   1336   1477   1633    OFF\r\n");
    CRLF1();
  
      GIE=1;
    i=0;
    Cpt6=0;
     drow = 0; dcol = 0;
  do
  { 
     RAZ_UART1_Buffer1();
      __delay_ms(2000); 
     //*(Buffer1+5)=0;
     if(  Flag_Buffer1==1)
     {    
     if  (  (*(Buffer1)=='R') && ( *(Buffer1+2)=='C') )
     {
       strcpy(CRam1,"cde=RxCx\r\n"); 
       cx=*(Buffer1+1);  
       if (  (cx>='0') && (cx<'4') )
       { 
         *(CRam1+5)=cx;
         drow= cx-48;
       }  
       cx=*(Buffer1+3);  
       if ( (cx>='0') && (cx<'4') )
       {    
         *(CRam1+7)=cx;
         dcol= cx-48; 
       }
       Print(CRam1);
      } 
     }
    i=(drow<<2)+dcol;
    sprintf(txt," Leds: %s  Touche= %c   R=%c  C=%c  F1=%5d Hz   F2=%5d Hz\r\n",Leds_HT9170B[i],Sequence[i],drow+48,dcol+48,Frow_value[drow],Fcol_value[dcol]);
    Print(txt);
    BDA_periodA = Frow[drow];
    BDA_periodB = Fcol[dcol];
   //  PWM5CONbits.EN=1;
    TMR6_Init_500ms(0);
     while(PIR9bits.TMR6IF==0) 
    { 
      while(PIR4bits.TMR2IF==0);  // wait until PWM cycle starts (sync to PWM)
      PIR4bits.TMR2IF=0;
         PWM5CONbits.EN=1;
        // calc the A sinewave,
        waveA =waveA + BDA_periodA;                // zero-error Accumulation
       // pwm_1 = Sin64L[waveA_2 & 0x3F];        // Binary Divide output (/65536) and keep 6 bits
        pwm_1  = Sin64L[waveA_2 & 0x3F];        // Binary Divide output (/65536) and keep 6 bits
        // if(drow == 4) pwm = 0;        // disable if row is OFF
        // calc the B sinewave, and ADD the 2 waves together
        waveB =waveB + BDA_periodB;
        //pwm_1 += Sin64H[waveB_2 & 0x3F];  // only enable if col is ON
        pwm_1 =pwm_1+ Sin64H[waveB_2 & 0x3F];  // only enable if col is ON
        // scale the summed sinewaves and place in PWM module
        pwm_1 = (pwm_1 << 1);   // scale 0-200 back to 0-100 for PWM
        pwm_1 += 128;          // offset to centre waveform (100 into centre of 128)
       PWM5_LoadDutyValue(pwm_1);
       }
         PWM5CONbits.EN=0;
    // Delay_2sec(); 
  }while(1); 
     
}
/**
 Projet MPLABX : Portier Audiophone 2022 
 Version : 2022-1206
 Compile le Dec  6 2022 a 15:44:01 UTC
 avec version XC8 :  2360
 Hardware : PIC18F27K42 , FOSC interne =64MHz 
 UART1  RC6=TX  115200,8,N,1 
 Usage de Timer1 x fois 100mS , Timer4  100mS
 Config= HOME

 Init PWR5 (sortie r-aiguille sur RC4)
 Init Timer2 associ  PWM5 , tick=64S
 Test UP  Duty =   128 
 Duty =   256 
 Duty =   384 
 Duty =   512 
 Duty =   640 
 Duty =   768 
 Duty =   896 
 Init et test Timer6 -> 8 x 500mS : ..........

 Sinewave DTMF generator
 Select the 2 DTMF tones
 Row :   697    770    852    941    OFF
 Col :  1209   1336   1477   1633    OFF

 Leds: LLLH  Touche= 1   R=0  C=0  F1=  697 Hz   F2= 1209 Hz
R0C1
cde=R0C1
 Leds: LLHL  Touche= 2   R=0  C=1  F1=  697 Hz   F2= 1336 Hz
 Leds: LLHL  Touche= 2   R=0  C=1  F1=  697 Hz   F2= 1336 Hz
 Leds: LLHL  Touche= 2   R=0  C=1  F1=  697 Hz   F2= 1336 Hz
 
 
 
 
 
 
 * 
 * 
 *  Projet MPLABX : Portier Audiophone 2022 
 Version : 2022-1119
 Compile le Nov 20 2022 a 18:25:55 UTC
 avec version XC8 :  2360
 Hardware : PIC18F27K42 , FOSC interne =64MHz 
 UART1  RC6=TX  115200,8,N,1 .. PAS DE RECEPTION sur RX  !
 Usage de Timer1 x fois 100mS , Timer4  100mS
 Config= HOME

Bonjour
 Init PWR5 (sortie sur RC5) 
 Init Timer2 associ  PWM5 , tick=64S
 Test UP  Duty =   128 
 Duty =   256 
 Duty =   384 
 Duty =   512 
 Duty =   640 
 Duty =   768 
 Duty =   896 
 Duty =  1000 

  Appui sur touche clavier pour sortir du test
  Appui sur touche clavier pour sortir du test
 ...
  Appui sur touche clavier pour sortir du test
  Appui sur touche clavier pour sortir du test
 
Q
 Init et test Timer6 -> 8 x 500mS : ..........

 Sinewave DTMF generator
 Select the 2 DTMF tones
 Row :   697    770    852    941    OFF
 Col :  1209   1336   1477   1633    OFF

 R=0  C=0  F1=  697 Hz   F2= 1209 Hz
 R=0  C=0  F1=  697 Hz   F2= 1209 Hz
R3C3
cde=R3C3
 R=3  C=3  F1=  941 Hz   F2= 1633 Hz
R2C3
cde=R2C3
 R=2  C=3  F1=  852 Hz   F2= 1633 Hz
R0C0
cde=R0C0
 R=0  C=0  F1=  697 Hz   F2= 1209 Hz
 R=0  C=0  F1=  697 Hz   F2= 1209 Hz
R0C1
cde=R0C1
 R=0  C=1  F1=  697 Hz   F2= 1336 Hz
 R=0  C=1  F1=  697 Hz   F2= 1336 Hz
 
 * 
Memory Summary:
    Program space        used  2404h (  9220) of 20000h bytes   (  7.0%)
    Data space           used   33Dh (   829) of  2000h bytes   ( 10.1%)
    Configuration bits   used     5h (     5) of     5h words   (100.0%)
    EEPROM space         used     0h (     0) of   400h bytes   (  0.0%)
    ID Location space    used    10h (    16) of    10h bytes   (100.0%)

make[2]: Leaving directory 'C:/MPLABX_Projects/Generateur_DTMF_18F27K42_2022.X'
make[1]: Leaving directory 'C:/MPLABX_Projects/Generateur_DTMF_18F27K42_2022.X'

BUILD SUCCESSFUL (total time: 6s)
Loading code from C:/MPLABX_Projects/Generateur_DTMF_18F27K42_2022.X/dist/default/production/Generateur_DTMF_18F27K42_2022.X.production.hex...
Program loaded with pack,PIC18F-K_DFP,1.6.125,Microchip
Loading completed

*/
